package date2013;

public interface IDate2013 {

	final int[] DAYS_IN_MONTHS = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30,
			31 }; //the i'th cell contains the number of days in month i+1
	static final char SEPRARTOR = '-'; // the delimiter for the date string
	static final int YEAR2013 = 2013;

	/**
	 * Returns the date in format YYYY-MM-DD, for example 2013-05-31
	 */
	String toString();

	/**
	 * Returns the day of month for this date, ranging from 1 to the number of days in that month.
	 * E.g., for 2013-05-31 the method returns 31
	 */
	int getDayOfMonth();

	/**
	 * Returns the day of year for this date, ranging from 0 to 364.
	 * E.g., for 2013-05-31 the method returns 150
	 */
	int getDayOfYear();

	/**
	 * Returns the month for this date, ranging from 1 to 12.
	 * E.g., for 2013-05-31 the method returns 5
	 */
	int getMonth();

	/**
	 * Returns a date that is one day after this date.
	 * If the requested date exceeds the last day of the year, it returns null.
	 * E.g., for 2013-05-31 the method returns a date that represents 2013-06-01
	 */
	IDate2013 advanceOneDay();

	/**
	 * Returns a date that is one month after this date.
	 * If the requested date exceeds the last day of the year, it returns null.
	 * If the requested day does not exist in the next month, it returns the last day of the next month
	 * E.g., for 2013-05-31 the method returns a date that represents 2013-06-30
	 */
	IDate2013 advanceOneMonth();

	/**
	 * Returns true iff other is not null and this date comes before or equal to the other date
	 * E.g., for 2013-05-31 and other representing 2013-07-01 it returns true
	 */
	boolean beforeOrEquals(IDate2013 other);

}
